--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gcc.target/i386/pr21101.c	24 Apr 2005 08:02:22 -0000	1.1.2.1
@@ -0,0 +1,32 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -funroll-loops -march=nocona" } */
+
+#include <mmintrin.h>
+
+int W;
+void f()
+{
+  int j;
+  int B, C;
+  unsigned char* S;
+  __m64 *T = (__m64 *) &W;
+
+  for (j = 0; j < 16; j++, T++)
+  {
+    T[0] = T[1] = _mm_set1_pi8(*S);
+    S += W;
+  }
+
+  C = 3 * B;
+
+  __m64 E = _mm_set_pi16(3 * B, 3 * B, 3 * B, 5 * B);
+  __m64 G = _mm_set1_pi16(3 * B);
+
+  for (j = 0; j < 16; j++)
+  {
+    __m64 R = _mm_set1_pi16(B + j * C);
+    R = _m_paddw(R, E);
+    R = _m_paddw(R, G);
+    T[0] = _mm_srai_pi16(R, 3);
+  }
+}
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/common_5.f	24 Apr 2005 13:59:58 -0000	1.1.2.1
@@ -0,0 +1,10 @@
+C { dg-do compile }
+C PR 20059
+C Check that the warning for padding works correctly.
+      SUBROUTINE PLOTZ
+      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
+      COMMON /CCPOOL/ RMIN,RMAX,ZMIN,ZMAX,IMIN,JMIN,IMAX,JMAX,NFLOP, ! { dg-warning "Padding" }
+     $ HTP
+C
+        RETURN
+      END
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/entry_3.f90	29 Apr 2005 02:41:17 -0000	1.1.2.1
@@ -0,0 +1,25 @@
+! { dg-do run }
+! Test assumed shape arrays in procedures with multiple entry points.
+! Arguments that aren't present in all entry points must be treated like
+! optional arguments.
+module entry_4
+contains
+subroutine foo(a)
+  integer, dimension(:) :: a
+  integer, dimension(:) :: b
+  a = (/1, 2/)
+  return
+entry bar(b)
+  b = (/3, 4/)
+end subroutine
+end module
+
+program entry_4_prog
+  use entry_4
+  integer :: a(2)
+  a = 0
+  call foo(a)
+  if (any (a .ne. (/1, 2/))) call abort
+  call bar(a)
+  if (any (a .ne. (/3, 4/))) call abort
+end program
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/entry_4.f90	29 Apr 2005 16:01:16 -0000	1.1.2.1
@@ -0,0 +1,28 @@
+! { dg-do compile { target i?86-*-* x86_64-*-* } }
+function f1 () result (r)		! { dg-error "can't be a POINTER" }
+integer, pointer :: r
+real e1
+allocate (r)
+r = 6
+return
+entry e1 ()
+e1 = 12
+entry e1a ()
+e1a = 13
+end function
+function f2 ()
+integer, dimension (2, 7, 6) :: e2	! { dg-error "can't be an array" }
+f2 = 6
+return
+entry e2 ()
+e2 (:, :, :) = 2
+end function
+integer*8 function f3 ()		! { dg-error "can't be of type" }
+complex*16 e3				! { dg-error "can't be of type" }
+f3 = 1
+return
+entry e3 ()
+e3 = 2
+entry e3a ()
+e3a = 3
+end function
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/ichar_1.f90	25 Apr 2005 00:09:17 -0000	1.1.2.1
@@ -0,0 +1,50 @@
+! { dg-do compile }
+! PR20879
+! Check that we reject expressions longer than one character for the
+! ICHAR and IACHAR intrinsics.
+
+! Assumed length variables are special because the frontend doesn't have
+! an expression for their length
+subroutine test (c)
+  character(len=*) :: c
+  integer i
+  i = ichar(c)
+  i = ichar(c(2:))
+  i = ichar(c(:1))
+end subroutine
+
+program ichar_1
+   integer i
+   integer, parameter :: j = 2
+   character(len=8) :: c = 'abcd'
+   character(len=1) :: g1(2)
+   character(len=1) :: g2(2,2)
+   character*1, parameter :: s1 = 'e'
+   character*2, parameter :: s2 = 'ef'
+
+   if (ichar(c(3:3)) /= 97) call abort
+   if (ichar(c(:1)) /= 97) call abort
+   if (ichar(c(j:j)) /= 98) call abort
+   if (ichar(s1) /= 101) call abort
+   if (ichar('f') /= 102) call abort
+   g1(1) = 'a'
+   if (ichar(g1(1)) /= 97) call abort
+   if (ichar(g1(1)(:)) /= 97) call abort
+   g2(1,1) = 'a'
+   if (ichar(g2(1,1)) /= 97) call abort
+
+   i = ichar(c)      ! { dg-error "must be of length one" "" }
+   i = ichar(c(:))   ! { dg-error "must be of length one" "" }
+   i = ichar(s2)     ! { dg-error "must be of length one" "" }
+   i = ichar(c(1:2)) ! { dg-error "must be of length one" "" }
+   i = ichar(c(1:))  ! { dg-error "must be of length one" "" }
+   i = ichar('abc')  ! { dg-error "must be of length one" "" }
+
+   ! ichar and iachar use the same checking routines. DO a couple of tests to
+   ! make sure it's not totally broken.
+
+   if (ichar(c(3:3)) /= 97) call abort
+   i = ichar(c)      ! { dg-error "must be of length one" "" }
+
+   call test(g1(1))
+end program ichar_1
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/pr16861.f90	29 Apr 2005 10:56:18 -0000	1.1.4.1
@@ -0,0 +1,32 @@
+! PR fortran/16861
+! { dg-do run }
+module foo
+  integer :: i
+end module foo
+
+module bar
+contains
+  subroutine baz(j)
+    use foo
+    integer, dimension(i) :: j
+    integer :: n
+
+    do n = 1, i
+      if (j(n) /= n**2) call abort
+    end do
+  end subroutine baz
+end module bar
+
+subroutine quus()
+  use foo
+  use bar
+
+  i = 2
+  call baz ((/1,4/))
+  i = 7
+  call baz ((/1,4,9,16,25,36,49/))
+end subroutine quus
+
+program test
+  call quus
+end program test
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/pr20865.f90	28 Apr 2005 11:56:02 -0000	1.1.2.1
@@ -0,0 +1,10 @@
+! { dg-do compile }
+! PR fortran/20865
+  subroutine tt(j)
+   integer :: j
+  end subroutine
+
+  integer :: i, st
+  st(i) = (i*i+2)
+  call tt(st) ! { dg-error "Statement function .* is not allowed as an actual argument" }
+  end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/pr20950.f	27 Apr 2005 18:15:37 -0000	1.1.4.1
@@ -0,0 +1,7 @@
+! PR libfortran/20950
+! Original bug-report by Walt Brainerd, The Fortran Company
+! { dg-do run }
+      character*20 c
+      inquire (33, sequential = c)
+      if (c .ne. "UNKNOWN") call abort
+      end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/pr21177.f90	27 Apr 2005 15:42:52 -0000	1.1.2.1
@@ -0,0 +1,53 @@
+! { dg-do run }
+! PR fortran/21177
+module mymod
+  interface tt
+    module procedure tt_i, tt_r, tt_l, tt_c4, tt_c8
+  end interface tt
+contains
+  function tt_l(x) result(y)
+    integer :: y
+    logical, pointer :: x
+    y = 0
+  end function
+  function tt_i(x) result(y)
+    integer :: y
+    integer, pointer :: x
+    y = 1
+  end function
+  function tt_r(x) result(y)
+    integer :: y
+    real, pointer :: x
+    y = 2
+  end function
+  function tt_c4(x) result(y)
+    integer :: y
+    complex(4), pointer :: x
+    y = 3
+  end function
+  function tt_c8(x) result(y)
+    integer :: y
+    complex(8), pointer :: x
+    y = 4
+  end function
+end module mymod
+
+program test
+  use mymod
+  logical, pointer :: l
+  integer, pointer :: i
+  real, pointer :: r
+  complex(4), pointer :: c4
+  complex(8), pointer :: c8
+  
+  if (tt(l) /= 0) call abort()
+  if (tt(i) /= 1) call abort()
+  if (tt(r) /= 2) call abort()
+  if (tt(c4) /= 3) call abort()
+  if (tt(c8) /= 4) call abort()
+  if (tt(null(l)) /= 0) call abort()
+  if (tt(null(i)) /= 1) call abort()
+  if (tt(null(r)) /= 2) call abort()
+  if (tt(null(c4)) /= 3) call abort()
+  if (tt(null(c8)) /= 4) call abort()
+end program test
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/wtruncate.f	23 Apr 2005 14:09:02 -0000	1.1.2.1
@@ -0,0 +1,10 @@
+! { dg-do compile }
+! { dg-options "-Wall" }
+
+! This long comment line should not trigger a line-truncation warning with -Wall
+
+      PROGRAM foo
+      WRITE (*,*) "Test"           ! Neither this comment which exceeds the 72 character limit, too
+      WRITE (*,*) "This exactly 72 character long source line not, too."
+      END
+
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.dg/wtruncate.f90	23 Apr 2005 14:09:02 -0000	1.1.2.1
@@ -0,0 +1,10 @@
+! { dg-do compile }
+! { dg-options "-Wall" }
+
+! This long comment line should not trigger a line-truncation warning with -Wall even for free-form 132 character line limit (blah blah)
+
+      PROGRAM foo
+      WRITE (*,*) "Test"           ! Neither this comment which exceeds the 132 character limit with some random words, too (blah blah)
+      WRITE (*,*) "This exactly 132 character long source line not, too.  How can people fill 132 characters without sensless stuff"
+      END
+
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_1.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,74 @@
+! Test alternate entry points for functions when the result types
+! of all entry points match
+
+	function f1 (a)
+	integer a, b, f1, e1
+	f1 = 15 + a
+	return
+	entry e1 (b)
+	e1 = 42 + b
+	end function
+	function f2 ()
+	real f2, e2
+	entry e2 ()
+	e2 = 45
+	end function
+	function f3 ()
+	double precision a, b, f3, e3
+	entry e3 ()
+	f3 = 47
+	end function
+	function f4 (a) result (r)
+	double precision a, b, r, s
+	r = 15 + a
+	return
+	entry e4 (b) result (s)
+	s = 42 + b
+	end function
+	function f5 () result (r)
+	integer r, s
+	entry e5 () result (s)
+	r = 45
+	end function
+	function f6 () result (r)
+	real r, s
+	entry e6 () result (s)
+	s = 47
+	end function
+	function f7 ()
+	entry e7 ()
+	e7 = 163
+	end function
+	function f8 () result (r)
+	entry e8 ()
+	e8 = 115
+	end function
+	function f9 ()
+	entry e9 () result (r)
+	r = 119
+	end function
+
+	program entrytest
+	integer f1, e1, f5, e5
+	real f2, e2, f6, e6, f7, e7, f8, e8, f9, e9
+	double precision f3, e3, f4, e4, d
+	if (f1 (6) .ne. 21) call abort ()
+	if (e1 (7) .ne. 49) call abort ()
+	if (f2 () .ne. 45) call abort ()
+	if (e2 () .ne. 45) call abort ()
+	if (f3 () .ne. 47) call abort ()
+	if (e3 () .ne. 47) call abort ()
+	d = 17
+	if (f4 (d) .ne. 32) call abort ()
+	if (e4 (d) .ne. 59) call abort ()
+	if (f5 () .ne. 45) call abort ()
+	if (e5 () .ne. 45) call abort ()
+	if (f6 () .ne. 47) call abort ()
+	if (e6 () .ne. 47) call abort ()
+	if (f7 () .ne. 163) call abort ()
+	if (e7 () .ne. 163) call abort ()
+	if (f8 () .ne. 115) call abort ()
+	if (e8 () .ne. 115) call abort ()
+	if (f9 () .ne. 119) call abort ()
+	if (e9 () .ne. 119) call abort ()
+	end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_2.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,51 @@
+! Test alternate entry points for functions when the result types
+! of all entry points match
+
+	character*(*) function f1 (str, i, j)
+	character str*(*), e1*(*), e2*(*)
+	integer i, j
+	f1 = str (i:j)
+	return
+	entry e1 (str, i, j)
+	i = i + 1
+	entry e2 (str, i, j)
+	j = j - 1
+	e2 = str (i:j)
+	end function
+
+	character*5 function f3 ()
+	character e3*(*), e4*(*)
+	integer i
+	f3 = 'ABCDE'
+	return
+	entry e3 (i)
+	entry e4 (i)
+	if (i .gt. 0) then
+	  e3 = 'abcde'
+	else
+	  e4 = 'UVWXY'
+	endif
+	end function
+
+	program entrytest
+	character f1*16, e1*16, e2*16, str*16, ret*16
+	character f3*5, e3*5, e4*5
+	integer i, j
+	str = 'ABCDEFGHIJ'
+	i = 2
+	j = 6
+	ret = f1 (str, i, j)
+	if ((i .ne. 2) .or. (j .ne. 6)) call abort ()
+	if (ret .ne. 'BCDEF') call abort ()
+	ret = e1 (str, i, j)
+	if ((i .ne. 3) .or. (j .ne. 5)) call abort ()
+	if (ret .ne. 'CDE') call abort ()
+	ret = e2 (str, i, j)
+	if ((i .ne. 3) .or. (j .ne. 4)) call abort ()
+	if (ret .ne. 'CD') call abort ()
+	if (f3 () .ne. 'ABCDE') call abort ()
+	if (e3 (1) .ne. 'abcde') call abort ()
+	if (e4 (1) .ne. 'abcde') call abort ()
+	if (e3 (0) .ne. 'UVWXY') call abort ()
+	if (e4 (0) .ne. 'UVWXY') call abort ()
+	end program
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_3.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,40 @@
+	subroutine f1 (n, *, i)
+	integer n, i
+	if (i .ne. 42) call abort ()
+	entry e1 (n, *)
+	if (n .eq. 1) return 1
+	if (n .eq. 2) return
+	return
+	entry e2 (n, i, *, *, *)
+	if (i .ne. 46) call abort ()
+	if (n .ge. 4) return
+	return n
+	entry e3 (n, i)
+	if ((i .ne. 48) .or. (n .ne. 61)) call abort ()
+	end subroutine
+
+	program alt_return
+	implicit none
+
+	call f1 (1, *10, 42)
+20	continue
+	call abort ()
+10	continue
+	call f1 (2, *20, 42)
+	call f1 (3, *20, 42)
+	call e1 (2, *20)
+	call e1 (1, *30)
+	call abort ()
+30	continue
+	call e2 (1, 46, *40, *20, *20)
+	call abort ()
+40	continue
+	call e2 (2, 46, *20, *50, *20)
+	call abort ()
+50	continue
+	call e2 (3, 46, *20, *20, *60)
+	call abort ()
+60	continue
+	call e2 (4, 46, *20, *20, *20)
+	call e3 (61, 48)
+	end program
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_4.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,64 @@
+! Test alternate entry points for functions when the result types
+! of all entry points don't match
+
+	integer function f1 (a)
+	integer a, b
+	double precision e1
+	f1 = 15 + a
+	return
+	entry e1 (b)
+	e1 = 42 + b
+	end function
+	complex function f2 (a)
+	integer a
+	logical e2
+	entry e2 (a)
+	if (a .gt. 0) then
+	  e2 = a .lt. 46
+	else
+	  f2 = 45
+	endif
+	end function
+	function f3 (a) result (r)
+	integer a, b
+	real r
+	logical s
+	complex c
+	r = 15 + a
+	return
+	entry e3 (b) result (s)
+	s = b .eq. 42
+	return
+	entry g3 (b) result (c)
+	c = b + 11
+	end function
+	function f4 (a) result (r)
+	logical r
+	integer a, s
+	double precision t
+	entry e4 (a) result (s)
+	entry g4 (a) result (t)
+	r = a .lt. 0
+	if (a .eq. 0) s = 16 + a
+	if (a .gt. 0) t = 17 + a
+	end function
+
+	program entrytest
+	integer f1, e4
+	real f3
+	double precision e1, g4
+	logical e2, e3, f4
+	complex f2, g3
+	if (f1 (6) .ne. 21) call abort ()
+	if (e1 (7) .ne. 49) call abort ()
+	if (f2 (0) .ne. 45) call abort ()
+	if (.not. e2 (45)) call abort ()
+	if (e2 (46)) call abort ()
+	if (f3 (17) .ne. 32) call abort ()
+	if (.not. e3 (42)) call abort ()
+	if (e3 (41)) call abort ()
+	if (g3 (12) .ne. 23) call abort ()
+	if (.not. f4 (-5)) call abort ()
+	if (e4 (0) .ne. 16) call abort ()
+	if (g4 (2) .ne. 19) call abort ()
+	end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_5.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,51 @@
+! Test alternate entry points for functions when the result types
+! of all entry points match
+
+	function f1 (str, i, j) result (r)
+	character str*(*), r1*(*), r2*(*), r*(*)
+	integer i, j
+	r = str (i:j)
+	return
+	entry e1 (str, i, j) result (r1)
+	i = i + 1
+	entry e2 (str, i, j) result (r2)
+	j = j - 1
+	r2 = str (i:j)
+	end function
+
+	function f3 () result (r)
+	character r3*5, r4*5, r*5
+	integer i
+	r = 'ABCDE'
+	return
+	entry e3 (i) result (r3)
+	entry e4 (i) result (r4)
+	if (i .gt. 0) then
+	  r3 = 'abcde'
+	else
+	  r4 = 'UVWXY'
+	endif
+	end function
+
+	program entrytest
+	character f1*16, e1*16, e2*16, str*16, ret*16
+	character f3*5, e3*5, e4*5
+	integer i, j
+	str = 'ABCDEFGHIJ'
+	i = 2
+	j = 6
+	ret = f1 (str, i, j)
+	if ((i .ne. 2) .or. (j .ne. 6)) call abort ()
+	if (ret .ne. 'BCDEF') call abort ()
+	ret = e1 (str, i, j)
+	if ((i .ne. 3) .or. (j .ne. 5)) call abort ()
+	if (ret .ne. 'CDE') call abort ()
+	ret = e2 (str, i, j)
+	if ((i .ne. 3) .or. (j .ne. 4)) call abort ()
+	if (ret .ne. 'CD') call abort ()
+	if (f3 () .ne. 'ABCDE') call abort ()
+	if (e3 (1) .ne. 'abcde') call abort ()
+	if (e4 (1) .ne. 'abcde') call abort ()
+	if (e3 (0) .ne. 'UVWXY') call abort ()
+	if (e4 (0) .ne. 'UVWXY') call abort ()
+	end program
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_6.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,109 @@
+! Test alternate entry points for functions when the result types
+! of all entry points match
+
+	function f1 (a)
+	integer, dimension (2, 2) :: a, b, f1, e1
+	f1 (:, :) = 15 + a (1, 1)
+	return
+	entry e1 (b)
+	e1 (:, :) = 42 + b (1, 1)
+	end function
+	function f2 ()
+	real, dimension (2, 2) :: f2, e2
+	entry e2 ()
+	e2 (:, :) = 45
+	end function
+	function f3 ()
+	double precision, dimension (2, 2) :: a, b, f3, e3
+	entry e3 ()
+	f3 (:, :) = 47
+	end function
+	function f4 (a) result (r)
+	double precision, dimension (2, 2) :: a, b, r, s
+	r (:, :) = 15 + a (1, 1)
+	return
+	entry e4 (b) result (s)
+	s (:, :) = 42 + b (1, 1)
+	end function
+	function f5 () result (r)
+	integer, dimension (2, 2) :: r, s
+	entry e5 () result (s)
+	r (:, :) = 45
+	end function
+	function f6 () result (r)
+	real, dimension (2, 2) :: r, s
+	entry e6 () result (s)
+	s (:, :) = 47
+	end function
+
+	program entrytest
+	interface
+	function f1 (a)
+	integer, dimension (2, 2) :: a, f1
+	end function
+	function e1 (b)
+	integer, dimension (2, 2) :: b, e1
+	end function
+	function f2 ()
+	real, dimension (2, 2) :: f2
+	end function
+	function e2 ()
+	real, dimension (2, 2) :: e2
+	end function
+	function f3 ()
+	double precision, dimension (2, 2) :: f3
+	end function
+	function e3 ()
+	double precision, dimension (2, 2) :: e3
+	end function
+	function f4 (a)
+ 	double precision, dimension (2, 2) :: a, f4
+	end function
+	function e4 (b)
+ 	double precision, dimension (2, 2) :: b, e4
+	end function
+	function f5 ()
+	integer, dimension (2, 2) :: f5
+	end function
+	function e5 ()
+	integer, dimension (2, 2) :: e5
+	end function
+	function f6 ()
+	real, dimension (2, 2) :: f6
+	end function
+	function e6 ()
+	real, dimension (2, 2) :: e6
+	end function
+	end interface
+	integer, dimension (2, 2) :: i, j
+	real, dimension (2, 2) :: r
+	double precision, dimension (2, 2) :: d, e
+	i (:, :) = 6
+	j = f1 (i)
+	if (any (j .ne. 21)) call abort ()
+	i (:, :) = 7
+	j = e1 (i)
+	j (:, :) = 49
+	if (any (j .ne. 49)) call abort ()
+	r = f2 ()
+	if (any (r .ne. 45)) call abort ()
+	r = e2 ()
+	if (any (r .ne. 45)) call abort ()
+	e = f3 ()
+	if (any (e .ne. 47)) call abort ()
+	e = e3 ()
+	if (any (e .ne. 47)) call abort ()
+	d (:, :) = 17
+	e = f4 (d)
+	if (any (e .ne. 32)) call abort ()
+	e = e4 (d)
+	if (any (e .ne. 59)) call abort ()
+	j = f5 ()
+	if (any (j .ne. 45)) call abort ()
+	j = e5 ()
+	if (any (j .ne. 45)) call abort ()
+	r = f6 ()
+	if (any (r .ne. 47)) call abort ()
+	r = e6 ()
+	if (any (r .ne. 47)) call abort ()
+	end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_7.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,106 @@
+! Test alternate entry points for functions when the result types
+! of all entry points match
+
+	function f1 (a)
+	integer a, b
+	integer, pointer :: f1, e1
+	allocate (f1)
+	f1 = 15 + a
+	return
+	entry e1 (b)
+	allocate (e1)
+	e1 = 42 + b
+	end function
+	function f2 ()
+	real, pointer :: f2, e2
+	entry e2 ()
+	allocate (e2)
+	e2 = 45
+	end function
+	function f3 ()
+	double precision, pointer :: f3, e3
+	entry e3 ()
+	allocate (f3)
+	f3 = 47
+	end function
+	function f4 (a) result (r)
+	double precision a, b
+	double precision, pointer :: r, s
+	allocate (r)
+	r = 15 + a
+	return
+	entry e4 (b) result (s)
+	allocate (s)
+	s = 42 + b
+	end function
+	function f5 () result (r)
+	integer, pointer :: r, s
+	entry e5 () result (s)
+	allocate (r)
+	r = 45
+	end function
+	function f6 () result (r)
+	real, pointer :: r, s
+	entry e6 () result (s)
+	allocate (s)
+	s = 47
+	end function
+
+	program entrytest
+	interface
+	function f1 (a)
+	integer a
+	integer, pointer :: f1
+	end function
+	function e1 (b)
+	integer b
+	integer, pointer :: e1
+	end function
+	function f2 ()
+	real, pointer :: f2
+	end function
+	function e2 ()
+	real, pointer :: e2
+	end function
+	function f3 ()
+	double precision, pointer :: f3
+	end function
+	function e3 ()
+	double precision, pointer :: e3
+	end function
+	function f4 (a)
+	double precision a
+	double precision, pointer :: f4
+	end function
+	function e4 (b)
+	double precision b
+	double precision, pointer :: e4
+	end function
+	function f5 ()
+	integer, pointer :: f5
+	end function
+	function e5 ()
+	integer, pointer :: e5
+	end function
+	function f6 ()
+	real, pointer :: f6
+	end function
+	function e6 ()
+	real, pointer :: e6
+	end function
+	end interface
+	double precision d
+	if (f1 (6) .ne. 21) call abort ()
+	if (e1 (7) .ne. 49) call abort ()
+	if (f2 () .ne. 45) call abort ()
+	if (e2 () .ne. 45) call abort ()
+	if (f3 () .ne. 47) call abort ()
+	if (e3 () .ne. 47) call abort ()
+	d = 17
+	if (f4 (d) .ne. 32) call abort ()
+	if (e4 (d) .ne. 59) call abort ()
+	if (f5 () .ne. 45) call abort ()
+	if (e5 () .ne. 45) call abort ()
+	if (f6 () .ne. 47) call abort ()
+	if (e6 () .ne. 47) call abort ()
+	end
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/testsuite/gfortran.fortran-torture/execute/entry_8.f90	29 Apr 2005 16:01:17 -0000	1.1.2.1
@@ -0,0 +1,24 @@
+module entry_8_m
+type t
+  integer i
+  real x (5)
+end type t
+end module entry_8_m
+
+function f (i)
+  use entry_8_m
+  type (t) :: f,g
+  f % i = i
+  return
+  entry g (x)
+  g%x = x
+end function f
+
+use entry_8_m
+type (t) :: f, g, res
+
+res = f (42)
+if (res%i /= 42) call abort ()
+res = g (1.)
+if (any (res%x /= 1.)) call abort ()
+end
--- gcc-4.0.0.orig/gcc/testsuite/lib/fortran-torture.exp	12 Sep 2004 18:07:28 -0000	1.6
+++ gcc-4.0.0/gcc/testsuite/lib/fortran-torture.exp	29 Apr 2005 00:06:57 -0000	1.6.32.1
@@ -180,7 +180,7 @@
 	# exist.  If not, the testcase should XFAIL.
 
 	# Compile the testcase.
-	remote_file build delete $executable
+	catch { remote_file build delete $executable }
 	verbose "Testing $testcase, $option" 1
 
 	set options ""
--- gcc-4.0.0.orig/include/ChangeLog	21 Apr 2005 05:19:45 -0000	1.170.4.1
+++ gcc-4.0.0/include/ChangeLog	26 Apr 2005 00:17:18 -0000	1.170.4.3
@@ -1,3 +1,14 @@
+2005-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* libiberty.h (unlock_std_streams): New.
+
+2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* libiberty.h (fopen_unlocked, fdopen_unlocked, freopen_unlocked):
+	Provide prototypes for new functions.
+
+	* libiberty.h (unlock_stream): New.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/include/libiberty.h	14 Sep 2004 01:12:49 -0000	1.40
+++ gcc-4.0.0/include/libiberty.h	26 Apr 2005 00:17:18 -0000	1.40.30.2
@@ -1,6 +1,6 @@
 /* Function declarations for libiberty.
 
-   Copyright 2001, 2002 Free Software Foundation, Inc.
+   Copyright 2001, 2002, 2005 Free Software Foundation, Inc.
    
    Note - certain prototypes declared in this header file are for
    functions whoes implementation copyright does not belong to the
@@ -48,6 +48,28 @@
 #include <stdarg.h>
 #endif
 
+#include <stdio.h>
+
+/* If the OS supports it, ensure that the supplied stream is setup to
+   avoid any multi-threaded locking.  Otherwise leave the FILE pointer
+   unchanged.  If the stream is NULL do nothing.  */
+
+extern void unlock_stream PARAMS ((FILE *));
+
+/* If the OS supports it, ensure that the standard I/O streams, stdin,
+   stdout and stderr are setup to avoid any multi-threaded locking.
+   Otherwise do nothing.  */
+
+extern void unlock_std_streams PARAMS ((void));
+
+/* Open and return a FILE pointer.  If the OS supports it, ensure that
+   the stream is setup to avoid any multi-threaded locking.  Otherwise
+   return the FILE pointer unchanged.  */
+
+extern FILE *fopen_unlocked PARAMS ((const char *, const char *));
+extern FILE *fdopen_unlocked PARAMS ((int, const char *));
+extern FILE *freopen_unlocked PARAMS ((const char *, const char *, FILE *));
+
 /* Build an argument vector from a string.  Allocates memory using
    malloc.  Use freeargv to free the vector.  */
 
--- gcc-4.0.0.orig/libada/ChangeLog	21 Apr 2005 05:19:49 -0000	1.12.42.1
+++ gcc-4.0.0/libada/ChangeLog	28 Apr 2005 01:38:01 -0000	1.12.42.2
@@ -1,3 +1,7 @@
+2005-04-27  James E Wilson  <wilson@specifixinc.com>
+
+	* Makefile.in (html): New.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libcpp/ChangeLog	21 Apr 2005 05:19:51 -0000	1.56.2.5
+++ gcc-4.0.0/libcpp/ChangeLog	24 Apr 2005 22:54:10 -0000	1.56.2.7
@@ -1,3 +1,23 @@
+2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* configure.ac (libcpp_UNLOCKED_FUNCS): New.
+	(AC_CHECK_FUNCS, AC_CHECK_DECLS): Check for libcpp_UNLOCKED_FUNCS.
+	* system.h (putchar, getc, getchar, clearerr, feof, fileno,
+	fflush, fgetc, fgets, ferror, fread): Redefine to the associated
+	_unlocked function.
+	(fwrite_unlocked): Fix prototype.
+	
+	* configure, config.in: Regenerate.
+
+	* system.h (fopen, fdopen, freopen): Define these to the unlocked
+	libiberty functions.
+
+2005-04-19  Per Bothner  <per@bothner.com>
+
+	PR preprocessor/20907
+	* line-map.c (linemap_line_start): Fix bug when we need to increse
+	column_bits but can re-use the current line_map.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/libcpp/config.in	14 Feb 2005 08:52:24 -0000	1.4
+++ gcc-4.0.0/libcpp/config.in	24 Apr 2005 22:54:11 -0000	1.4.6.1
@@ -22,6 +22,9 @@
    */
 #undef HAVE_ALLOCA_H
 
+/* Define to 1 if you have the `clearerr_unlocked' function. */
+#undef HAVE_CLEARERR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `abort', and to 0 if you don't.
    */
 #undef HAVE_DECL_ABORT
@@ -30,10 +33,38 @@
    don't. */
 #undef HAVE_DECL_BASENAME
 
+/* Define to 1 if you have the declaration of `clearerr_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_CLEARERR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `errno', and to 0 if you don't.
    */
 #undef HAVE_DECL_ERRNO
 
+/* Define to 1 if you have the declaration of `feof_unlocked', and to 0 if you
+   don't. */
+#undef HAVE_DECL_FEOF_UNLOCKED
+
+/* Define to 1 if you have the declaration of `ferror_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FERROR_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fflush_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FFLUSH_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fgetc_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FGETC_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fgets_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FGETS_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fileno_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FILENO_UNLOCKED
+
 /* Define to 1 if you have the declaration of `fprintf_unlocked', and to 0 if
    you don't. */
 #undef HAVE_DECL_FPRINTF_UNLOCKED
@@ -46,14 +77,30 @@
    you don't. */
 #undef HAVE_DECL_FPUTS_UNLOCKED
 
+/* Define to 1 if you have the declaration of `fread_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FREAD_UNLOCKED
+
 /* Define to 1 if you have the declaration of `fwrite_unlocked', and to 0 if
    you don't. */
 #undef HAVE_DECL_FWRITE_UNLOCKED
 
+/* Define to 1 if you have the declaration of `getchar_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_GETCHAR_UNLOCKED
+
+/* Define to 1 if you have the declaration of `getc_unlocked', and to 0 if you
+   don't. */
+#undef HAVE_DECL_GETC_UNLOCKED
+
 /* Define to 1 if you have the declaration of `getopt', and to 0 if you don't.
    */
 #undef HAVE_DECL_GETOPT
 
+/* Define to 1 if you have the declaration of `putchar_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_PUTCHAR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `putc_unlocked', and to 0 if you
    don't. */
 #undef HAVE_DECL_PUTC_UNLOCKED
@@ -61,6 +108,24 @@
 /* Define to 1 if you have the <fcntl.h> header file. */
 #undef HAVE_FCNTL_H
 
+/* Define to 1 if you have the `feof_unlocked' function. */
+#undef HAVE_FEOF_UNLOCKED
+
+/* Define to 1 if you have the `ferror_unlocked' function. */
+#undef HAVE_FERROR_UNLOCKED
+
+/* Define to 1 if you have the `fflush_unlocked' function. */
+#undef HAVE_FFLUSH_UNLOCKED
+
+/* Define to 1 if you have the `fgetc_unlocked' function. */
+#undef HAVE_FGETC_UNLOCKED
+
+/* Define to 1 if you have the `fgets_unlocked' function. */
+#undef HAVE_FGETS_UNLOCKED
+
+/* Define to 1 if you have the `fileno_unlocked' function. */
+#undef HAVE_FILENO_UNLOCKED
+
 /* Define to 1 if you have the `fprintf_unlocked' function. */
 #undef HAVE_FPRINTF_UNLOCKED
 
@@ -70,9 +135,18 @@
 /* Define to 1 if you have the `fputs_unlocked' function. */
 #undef HAVE_FPUTS_UNLOCKED
 
+/* Define to 1 if you have the `fread_unlocked' function. */
+#undef HAVE_FREAD_UNLOCKED
+
 /* Define to 1 if you have the `fwrite_unlocked' function. */
 #undef HAVE_FWRITE_UNLOCKED
 
+/* Define to 1 if you have the `getchar_unlocked' function. */
+#undef HAVE_GETCHAR_UNLOCKED
+
+/* Define to 1 if you have the `getc_unlocked' function. */
+#undef HAVE_GETC_UNLOCKED
+
 /* Define if you have the iconv() function. */
 #undef HAVE_ICONV
 
@@ -97,6 +171,9 @@
 /* Define to 1 if libc includes obstacks. */
 #undef HAVE_OBSTACK
 
+/* Define to 1 if you have the `putchar_unlocked' function. */
+#undef HAVE_PUTCHAR_UNLOCKED
+
 /* Define to 1 if you have the `putc_unlocked' function. */
 #undef HAVE_PUTC_UNLOCKED
 
--- gcc-4.0.0.orig/libcpp/configure.ac	19 Mar 2005 20:24:06 -0000	1.11.6.1
+++ gcc-4.0.0/libcpp/configure.ac	24 Apr 2005 22:54:10 -0000	1.11.6.2
@@ -44,10 +44,13 @@
 AC_STRUCT_TM
 AC_CHECK_SIZEOF(int)
 AC_CHECK_SIZEOF(long)
-AC_CHECK_FUNCS(putc_unlocked fputc_unlocked fputs_unlocked \
-        fwrite_unlocked fprintf_unlocked)
-AC_CHECK_DECLS([abort, basename, errno, getopt, putc_unlocked, fputc_unlocked,
-        fputs_unlocked, fwrite_unlocked, fprintf_unlocked])
+define(libcpp_UNLOCKED_FUNCS, clearerr_unlocked feof_unlocked dnl
+  ferror_unlocked fflush_unlocked fgetc_unlocked fgets_unlocked dnl
+  fileno_unlocked fprintf_unlocked fputc_unlocked fputs_unlocked dnl
+  fread_unlocked fwrite_unlocked getchar_unlocked getc_unlocked dnl
+  putchar_unlocked putc_unlocked)
+AC_CHECK_FUNCS(libcpp_UNLOCKED_FUNCS)
+AC_CHECK_DECLS(m4_split(m4_normalize(abort basename errno getopt libcpp_UNLOCKED_FUNCS)))
 
 # Checks for library functions.
 AC_FUNC_ALLOCA
--- gcc-4.0.0.orig/libcpp/line-map.c	24 May 2004 10:50:44 -0000	1.1
+++ gcc-4.0.0/libcpp/line-map.c	24 Apr 2005 20:32:32 -0000	1.1.54.1
@@ -199,6 +199,8 @@
       int column_bits;
       if (max_column_hint > 100000 || highest > 0xC0000000)
 	{
+	  /* If the column number is ridiculous or we've allocated a huge
+	     number of source_locations, give up on column numbers. */
 	  max_column_hint = 0;
 	  if (highest >0xF0000000)
 	    return 0;
@@ -211,13 +213,15 @@
 	    column_bits++;
 	  max_column_hint = 1U << column_bits;
 	}
+      /* Allocate the new line_map.  However, if the current map only has a
+	 single line we can sometimes just increase its column_bits instead. */
       if (line_delta < 0
 	  || last_line != map->to_line
 	  || SOURCE_COLUMN (map, highest) >= (1U << column_bits))
 	map = (struct line_map*) linemap_add (set, LC_RENAME, map->sysp,
 				      map->to_file, to_line);
       map->column_bits = column_bits;
-      r = map->start_location;
+      r = map->start_location + ((to_line - map->to_line) << column_bits);
     }
   else
     r = highest - SOURCE_COLUMN (map, highest)
